package pl.alx.najprostszyopengl;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.ShortBuffer;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.opengl.GLSurfaceView.Renderer;

public class NajprostszyRenderer implements Renderer {
	FloatBuffer kwadratWierzcholki;
	{
		ByteBuffer bb = ByteBuffer.allocateDirect(4 * 3 * 4); // cztery punkty po trzy wsprzdne po cztery bajty
		bb.order(ByteOrder.nativeOrder()); 
		kwadratWierzcholki = bb.asFloatBuffer();
		kwadratWierzcholki.put(new float[] {
			-0.2f, 0.2f, 0, // NW
			0.2f, 0.2f, 0, // NE
			0.2f, -0.2f, 0, // SE
			-0.2f, -0.2f, 0 // SW
		});
		kwadratWierzcholki.position(0);
	}
	ShortBuffer kwadratPolaczenia;
	{
		ByteBuffer bb = ByteBuffer.allocateDirect(2 * 3 * 2); // dwa trjkty po trzy punkty po dwa bajty
		bb.order(ByteOrder.nativeOrder()); 
		kwadratPolaczenia = bb.asShortBuffer();
		kwadratPolaczenia.put(new short[] {
			0, 3, 2, // trjkt dolny-lewy
			2, 1, 0 // trjkt grny-prawy
		});
		kwadratPolaczenia.position(0);
	}
	
	public void onSurfaceCreated(GL10 gl, EGLConfig arg1) {
		gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
	}

	public void onSurfaceChanged(GL10 gl, int width, int height) {
		gl.glViewport(0, 0, width, height);
	}

	public void onDrawFrame(GL10 gl) {
		gl.glPushMatrix();
		gl.glColor4f(0, 0, 1, 1);
		gl.glVertexPointer(3, GL10.GL_FLOAT, 0, kwadratWierzcholki);
		gl.glDrawElements(
				GL10.GL_LINE_LOOP,
				kwadratPolaczenia.capacity(),
				GL10.GL_UNSIGNED_SHORT,
				kwadratPolaczenia
		);
		gl.glColor4f(1, 0, 0, 1);
		
//		przesunicie wzdu osi X
//		gl.glTranslatef(0.15f, 0, 0);
		
//		przesunicie wzdu osi Z
//		gl.glTranslatef(0, 0, 0.15f);
		
//		przeskalowanie
//		gl.glScalef(2, 2, 2);
	
//		najpierw przeskalowanie, potem przesunicie
//		gl.glScalef(2, 2, 2);
//		gl.glTranslatef(0.2f, 0, 0);

//		zagadka 1
//		gl.glTranslatef(0.4f, 0, 0);
//		gl.glRotatef(10, 0, 0, 1);
		
//		zagadka 2
//		gl.glRotatef(10, 0, 0, 1);
//		gl.glTranslatef(0.4f, 0, 0);

//		zagadka 3
		gl.glScalef(2, 1, 1);
		gl.glRotatef(45, 0, 0, 1);
		gl.glTranslatef(0.2f, 0, 0);
		
		gl.glDrawElements(
				GL10.GL_LINE_LOOP,
				kwadratPolaczenia.capacity(),
				GL10.GL_UNSIGNED_SHORT,
				kwadratPolaczenia
		);
		gl.glPopMatrix();
	}

}
